#
# Conditional build:
%bcond_without	tests		# do not perform "make test"
#
%include	/usr/lib/rpm/macros.perl
%define	pdir	UNIVERSAL
%define	pnam	can
Summary:	UNIVERSAL::can - Hack around people calling UNIVERSAL::can() as a function
Summary(pl.UTF-8):	UNIVERSAL::can - poprawianie ludzi wywołujących UNIVERSAL::can() jako funkcję
Name:		perl-UNIVERSAL-can
Version:	1.15
Release:	1
License:	GPL v1+ or Artistic
Group:		Development/Languages/Perl
Source0:	http://www.cpan.org/modules/by-module/UNIVERSAL/%{pdir}-%{pnam}-%{version}.tar.gz
# Source0-md5:	d08a0bdedccadebed359f2c0a7b5afbb
URL:		http://search.cpan.org/dist/UNIVERSAL-can/
BuildRequires:	perl-Module-Build
BuildRequires:	perl-devel >= 1:5.8.0
BuildRequires:	rpm-perlprov >= 4.1-13
%if %{with tests}
BuildRequires:	perl-Test-Simple >= 0.60
BuildRequires:	perl-Test-Warn >= 0.08
BuildRequires:	perl-Tree-DAG_Node
%endif
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The UNIVERSAL class provides a few default methods so that all objects
can use them. Object orientation allows programmers to override these
methods in subclasses to provide more specific and appropriate
behavior.

Some authors call methods in the UNIVERSAL class on potential
invocants as functions, bypassing any possible overriding. This is
wrong and you should not do it. Unfortunately, not everyone heeds this
warning and their bad code can break your good code.

Fortunately, this module replaces UNIVERSAL::can() with a method that
checks to see if the first argument is a valid invocant (whether an
object - a blessed referent - or the name of a class). If so, and if
the invocant's class has its own can() method, it calls that as a
method. Otherwise, everything works as you might expect.

If someone attempts to call UNIVERSAL::can() as a function, this
module will emit a lexical warning (see perllexwarn) to that effect.
You can disable it with no warnings; or no warnings 'UNIVERSAL::isa';,
but don't do that; fix the code instead.

%description -l pl.UTF-8
Klasa UNIVERSAL udostępnia kilka domyślnych metod, które mogą być
używane przez wszystkie obiekty. Zorientowanie obiektowe pozwala
programistom przykryć te metody w podklasach, aby zapewnić bardziej
konkretne i odpowiednie zachowanie.

Niektórzy autorzy wywołują metody w klasie UNIVERSAL na potencjalnych
wywołujących jako funkcje, pomijając jakiekolwiek przykrywanie. Jest
to niedobre i nie należy tego robić. Niestety nie każdy zwraca uwagę
na to ostrzeżenie i jego zły kod może zepsuć inny dobry kod.

Na szczęście ten moduł zastępuje UNIVERSAL::can() metodą sprawdzającą
czy pierwszy argument jest poprawnym wywołującym (obiektem -
pobłogosławioną referencją - albo nazwą klasy). Jeśli tak, a klasa
wywołującego ma własną metodę can(), wywołuje ją jako metodę. W
przeciwnym wypadku wszystko działa tak, jak można by się tego
spodziewać.

Jeśli ktoś próbuje wywołać UNIVERSAL::can() jako funkcję, ten moduł
wygeneruje ostrzeżenie słowne (perllexwarn). Można wyłączyć je - ale
nie należy tego robić, zamiast tego lepiej poprawić kod.

%prep
%setup -q -n %{pdir}-%{pnam}-%{version}

%build
%{__perl} Build.PL \
	destdir=$RPM_BUILD_ROOT \
	installdirs=vendor
./Build

%{?with_tests:./Build test}

%install
rm -rf $RPM_BUILD_ROOT

./Build install

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc Changes README
%{perl_vendorlib}/UNIVERSAL/*.pm
%{_mandir}/man3/*
%changelog
* Sun Sep 02 2018 TLD Linux <feedback@tld-linux.org>
- For complete changelog see: http://git.tld-linux.org/?p=packages/perl-UNIVERSAL-can.git;a=log;h=master

* Wed Sep 09 2009 amateja <amateja@pld-linux.org> bcded94
- updated to 1.15

* Sun Jul 27 2008 Arkadiusz Miśkiewicz <arekm@maven.pl> 6754234
- release 2

* Sat Mar 31 2007 Jakub Bogusz <qboosh@pld-linux.org> 39f0e10
- BR: perl-Module-Build

* Tue Feb 13 2007 Elan Ruusamäe <glen@pld-linux.org> 2d0649e
- tabs in preamble

* Mon Feb 12 2007 Jan Rękorajski <baggins@pld-linux.org> 733441d
- converted to UTF-8

* Thu May 25 2006 blaass <blaass@pld-linux.org> 56c2651
- up to 1.12

* Mon Feb 20 2006 Elan Ruusamäe <glen@pld-linux.org> 3d3f57e
- 1.11

* Tue Nov 15 2005 Jakub Bogusz <qboosh@pld-linux.org> 887374e
- pl, generic URL

* Mon Nov 07 2005 migo <migo@pld-linux.org> a4b6176
- initial revision

